package de.nwsnet.homework.eurocalc;

/*
 * Copyright (c) 2002, 2003 Jochen Kupperschmidt <jochen@kupperschmidt.de>
 * Released under the terms of the GNU General Public License
 *    _                               _
 *   | |_ ___ _____ ___ _ _ _ ___ ___| |_
 *   |   | . |     | ._| | | | . |  _| . /
 *   |_|_|___|_|_|_|___|_____|___|_| |_|_\
 *     http://homework.nwsnet.de/
 */

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * Program info ('about') screen for EuroCalc.
 *
 * @author  <a href="mailto:jochen@kupperschmidt.de">Jochen Kupperschmidt</a>
 * @version 28-Mar-2003
 */
class AboutDialog extends JDialog implements ActionListener {

    public AboutDialog(JFrame owner) {
        super(owner, "About " + Resources.getString("app.title"), true);
        setResizable(false);
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);

        JLabel logoLabel =
            new JLabel(Resources.getIcon("app.logo"), JLabel.CENTER);
        logoLabel.setAlignmentX(CENTER_ALIGNMENT);

        JLabel copyrightLabel = new  JLabel(
            "Copyright (c) 2002, 2003 Jochen Kupperschmidt", JLabel.CENTER);
        copyrightLabel.setAlignmentX(CENTER_ALIGNMENT);
        JLabel websiteLabel = new JLabel(
            "<html><u>http://homework.nwsnet.de/</u></html>", JLabel.CENTER);
        websiteLabel.setAlignmentX(CENTER_ALIGNMENT);

        JButton closeButton = new JButton("OK");
        closeButton.setAlignmentX(CENTER_ALIGNMENT);
        closeButton.setFocusPainted(false);
        closeButton.addActionListener(this);

        JPanel contentPane = new JPanel();
        contentPane.setBorder(BorderFactory.createEmptyBorder(8, 6, 6, 6));
        contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
        contentPane.add(logoLabel);
        contentPane.add(Box.createVerticalStrut(8));
        contentPane.add(copyrightLabel);
        contentPane.add(websiteLabel);
        contentPane.add(Box.createVerticalStrut(12));
        contentPane.add(closeButton);
        setContentPane(contentPane);
        pack();
    }

    public void actionPerformed(ActionEvent ae) {
        setVisible(false);
    }

	// overwrite to re-center dialog on parent frame
    public void setVisible(boolean visible) {
        setLocationRelativeTo(getOwner());
        super.setVisible(visible);
    }
}
