package de.nwsnet.homework.eurocalc;

/*
 * Copyright (c) 2002 Jochen Kupperschmidt <jochen@kupperschmidt.de>
 * Released under the terms of the GNU General Public License
 *    _                               _
 *   | |_ ___ _____ ___ _ _ _ ___ ___| |_
 *   |   | . |     | ._| | | | . |  _| . /
 *   |_|_|___|_|_|_|___|_____|___|_| |_|_\
 *     http://homework.nwsnet.de/
 */

import java.util.Collection;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

/**
 * Holds a collection of Currency objects.
 *
 * @author  <a href="mailto:jochen@kupperschmidt.de">Jochen Kupperschmidt</a>
 * @version 27-Mar-2003
 */
class Currencies {

    private Hashtable curr	= new Hashtable();
    private String current	= null;
			
    protected Currency getCurrency() {
        return getCurrency(current);
    }

	protected Currency getCurrency(String key) {
		if (curr.containsKey(key)) {
			return (Currency) curr.get(key);
		} else {
			System.err.println("Key '" + key + "' not found!");
			return null;
		}
	}

	protected void setCurrency(String key) {
		current = key;
	}

    protected void addCurrency(String longName, String shortName, double euroValue) {
        curr.put(shortName, new Currency(longName, shortName, euroValue));
    }

	protected Collection getCurrencies() {
		Vector keys = new Vector();
		for (Enumeration el = curr.keys(); el.hasMoreElements(); ) {
			keys.addElement((String) el.nextElement());
		}
		Collections.sort(keys);
		Vector values = new Vector();
		for (Enumeration el = keys.elements(); el.hasMoreElements(); ) {
			values.addElement((Currency) getCurrency((String) el.nextElement()));
		}
		return values;
	}
}
