package de.nwsnet.homework.eurocalc;

/*
 * Copyright (c) 2002, 2003 Jochen Kupperschmidt <jochen@kupperschmidt.de>
 * Released under the terms of the GNU General Public License
 *    _                               _
 *   | |_ ___ _____ ___ _ _ _ ___ ___| |_
 *   |   | . |     | ._| | | | . |  _| . /
 *   |_|_|___|_|_|_|___|_____|___|_| |_|_\
 *     http://homework.nwsnet.de/
 */

import java.awt.event.ActionListener;
import java.util.Iterator;

import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JRadioButtonMenuItem;

/**
 * Menu bar with ability to choose between currencies.
 *
 * @author  <a href="mailto:jochen@kupperschmidt.de">Jochen Kupperschmidt</a>
 * @version 28-Mar-2003
 */
class MenuBar extends JMenuBar {

    protected MenuBar(ActionListener listener, Currencies currencies) {
        JMenu menu;
        JMenuItem menuItem;
        JRadioButtonMenuItem radioBoxMenuItem;

        // program menu
        menu = new JMenu("Program");
        add(menu);

            // menu item 'about'
            menuItem = new JMenuItem("About");
            menuItem.setIcon(Resources.getIcon("icon.about"));
            menuItem.setActionCommand("ABOUT");
            menuItem.addActionListener(listener);
            menu.add(menuItem);

            menu.addSeparator();

            // menu item 'exit'
            menuItem = new JMenuItem("Exit");
            menuItem.setIcon(Resources.getIcon("icon.exit"));
            menuItem.setActionCommand("EXIT");
            menuItem.addActionListener(listener);
            menu.add(menuItem);

		// following menus will be aligned to the right
        add(Box.createHorizontalGlue());

        // currency menu
        menu = new JMenu("Currency");
        add(menu);

            // menu item 'overview'
            menuItem = new JMenuItem("Overview");
            menuItem.setActionCommand("CURRENCY_OVERVIEW");
            menuItem.addActionListener(listener);
            menu.add(menuItem);

            menu.addSeparator();

            // menu items to select currency
            ButtonGroup currencyMenuItemGroup = new ButtonGroup();
            Currency c;
            String current = currencies.getCurrency().getShortName();
            Iterator it = currencies.getCurrencies().iterator();
            while (it.hasNext()) {
            	c = (Currency) it.next();
                radioBoxMenuItem = new JRadioButtonMenuItem(
                        c.getLongName() + " (" + c.getShortName() + ")");
                radioBoxMenuItem.setIcon(
                    Resources.getIcon(c.getShortName() + "_ICON"));
                radioBoxMenuItem.setActionCommand(
                    "CURRENCY_CHANGE_TO_" + c.getShortName());
                radioBoxMenuItem.addActionListener(listener);
                if (c.getShortName().equals(current)) {
                    radioBoxMenuItem.setSelected(true);
                }
                currencyMenuItemGroup.add(radioBoxMenuItem);
                menu.add(radioBoxMenuItem);
			}
    }
}
