package de.nwsnet.homework.eurocalc;

/*
 * Copyright (c) 2002, 2003 Jochen Kupperschmidt <jochen@kupperschmidt.de>
 * Released under the terms of the GNU General Public License
 *    _                               _
 *   | |_ ___ _____ ___ _ _ _ ___ ___| |_
 *   |   | . |     | ._| | | | . |  _| . /
 *   |_|_|___|_|_|_|___|_____|___|_| |_|_\
 *     http://homework.nwsnet.de/
 */

import java.awt.Toolkit;
import java.net.URL;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import javax.swing.ImageIcon;

/**
 * Provides access to externalized strings, images, etc.
 *
 * @author  <a href="mailto:jochen@kupperschmidt.de">Jochen Kupperschmidt</a>
 * @version 11-Feb-2003
 */
public class Resources {

    private static final String BUNDLE_NAME
    	= "de.nwsnet.homework.eurocalc.resources.eurocalc";

    private static final ResourceBundle RESOURCE_BUNDLE
    	= ResourceBundle.getBundle(BUNDLE_NAME);

    public static String getString(String key) {
        try {
            return RESOURCE_BUNDLE.getString(key);
        } catch (MissingResourceException e) {
            return '#' + key + '#';
        }
    }

	public static ImageIcon getIcon(String key) {
        String iconfile = getString(key);
		try {
			URL url = (new Resources()).getClass().getResource(iconfile);
			if (url == null) {
				throw new NullPointerException("Bad URL");
			}
			return new ImageIcon(Toolkit.getDefaultToolkit().getImage(url));
		} catch (NullPointerException e) {
            System.err.println(
                "Resources: could not load image '" + iconfile + "': "
                + e.getMessage());
			return null;
		}
    }
}
